searchData={"items":[{"type":"module","doc":"A friendly expression language helps users define decision logic without needing deep technical expertise. This language is based on the FEEL(Friendly Enough Expression Language). For more information regarding FEEL, please take a look at the official OMG specification at https://www.omg.org/dmn/.","title":"FeelEx","ref":"FeelEx.html"},{"type":"function","doc":"Evaluates an expression.","title":"FeelEx.evaluate/1","ref":"FeelEx.html#evaluate/1"},{"type":"function","doc":"iex> FeelEx.evaluate(\"if true then 2+2 else 3+3\")\n    %FeelEx.Value{value: 4, type: :number}","title":"Examples - FeelEx.evaluate/1","ref":"FeelEx.html#evaluate/1-examples"},{"type":"function","doc":"Evaluates an expression against a context. See https://github.com/ExSemantic/feel_ex/blob/master/README.md\nto see more examples in detail.","title":"FeelEx.evaluate/2","ref":"FeelEx.html#evaluate/2"},{"type":"function","doc":"iex> FeelEx.evaluate(%{a: true}, \"if a then 2+2 else 3+3\")\n    %FeelEx.Value{value: 4, type: :number}","title":"Examples - FeelEx.evaluate/2","ref":"FeelEx.html#evaluate/2-examples"},{"type":"function","doc":"Run a unary test with a given unary expression and input value.","title":"FeelEx.unary_test/2","ref":"FeelEx.html#unary_test/2"},{"type":"function","doc":"iex FeelEx.unary_test(\"<5\",3)\n    %FeelEx.Value{value: true, type: :boolean}\n    iex> FeelEx.unary_test(\"<2\",3)\n    %FeelEx.Value{value: false, type: :boolean}\n    iex> FeelEx.unary_test(\"(2..5)\",3)\n    %FeelEx.Value{value: true, type: :boolean}\n    iex> FeelEx.unary_test(\"(2..5)\",2)\n    %FeelEx.Value{value: false, type: :boolean}\n    %FeelEx.Value{value: false, type: :boolean}\n    iex> FeelEx.unary_test(\"[2..5]\",5)\n    %FeelEx.Value{value: true, type: :boolean}\n    iex> FeelEx.unary_test(\"[2..5)\",5)\n    %FeelEx.Value{value: false, type: :boolean}","title":"Examples - FeelEx.unary_test/2","ref":"FeelEx.html#unary_test/2-examples"},{"type":"function","doc":"Run a unary test with a given unary expression, input value, context.","title":"FeelEx.unary_test/3","ref":"FeelEx.html#unary_test/3"},{"type":"function","doc":"iex> FeelEx.unary_test(\"  FeelEx.unary_test(\"<a\",3,%{a: 5})\n    %FeelEx.Value{value: true, type: :boolean}","title":"Examples - FeelEx.unary_test/3","ref":"FeelEx.html#unary_test/3-examples"},{"type":"module","doc":"This module defines a set of functions that may be used on FeelEx values.\n\nThese functions can be invoked in expressions.","title":"FeelEx.Functions","ref":"FeelEx.Functions.html"},{"type":"function","doc":"Returns the absolute value of the given number.","title":"FeelEx.Functions.abs/1","ref":"FeelEx.Functions.html#abs/1"},{"type":"function","doc":"iex> number = FeelEx.Value.new(-1.21)\n    %FeelEx.Value{value: -1.21, type: :number}\n    iex> FeelEx.Functions.abs(number)\n    %FeelEx.Value{value: 1.21, type: :number}\n    iex> number = FeelEx.Value.new(10)\n    %FeelEx.Value{value: 10, type: :number}\n    iex> FeelEx.Functions.abs(number)\n    %FeelEx.Value{value: 10, type: :number}","title":"Examples - FeelEx.Functions.abs/1","ref":"FeelEx.Functions.html#abs/1-examples"},{"type":"function","doc":"Expects a list of bollean values.\nReturns true if all elements in a list are true, otherwise returns false.\nIf the given list is empty it returns true.","title":"FeelEx.Functions.all/1","ref":"FeelEx.Functions.html#all/1"},{"type":"function","doc":"iex> value = FeelEx.Value.new([true,false])\n    [\n      %FeelEx.Value{value: true, type: :boolean},\n      %FeelEx.Value{value: false, type: :boolean}\n    ]\n    iex> FeelEx.Functions.all(value)\n    %FeelEx.Value{value: false, type: :boolean}\n    iex> value = FeelEx.Value.new([false,nil,true,false])\n    [\n      %FeelEx.Value{value: false, type: :boolean},\n      %FeelEx.Value{value: nil, type: :null},\n      %FeelEx.Value{value: true, type: :boolean},\n      %FeelEx.Value{value: false, type: :boolean}\n    ]\n    iex> FeelEx.Functions.all(value)\n    %FeelEx.Value{value: false, type: :boolean}","title":"Examples - FeelEx.Functions.all/1","ref":"FeelEx.Functions.html#all/1-examples"},{"type":"function","doc":"Returns true if any element of the given list is true. Othewise return false.\nIf the given list is empty return false.","title":"FeelEx.Functions.any/1","ref":"FeelEx.Functions.html#any/1"},{"type":"function","doc":"iex> value = FeelEx.Value.new([false,true])\n    [\n      %FeelEx.Value{value: false, type: :boolean},\n      %FeelEx.Value{value: true, type: :boolean}\n    ]\n    iex> FeelEx.Functions.any(value)\n    %FeelEx.Value{value: true, type: :boolean}","title":"Examples - FeelEx.Functions.any/1","ref":"FeelEx.Functions.html#any/1-examples"},{"type":"function","doc":"Append a list of items to a list.","title":"FeelEx.Functions.append/2","ref":"FeelEx.Functions.html#append/2"},{"type":"function","doc":"iex> list = FeelEx.Value.new([1,2,3])\n    [\n      %FeelEx.Value{value: 1, type: :number},\n      %FeelEx.Value{value: 2, type: :number},\n      %FeelEx.Value{value: 3, type: :number}\n    ]\n    iex> items = FeelEx.Value.new([\"a\",\"b\"])\n    [\n      %FeelEx.Value{value: \"a\", type: :string},\n      %FeelEx.Value{value: \"b\", type: :string}\n    ]\n    iex> FeelEx.Functions.append(list,items)\n    [\n      %FeelEx.Value{value: 1, type: :number},\n      %FeelEx.Value{value: 2, type: :number},\n      %FeelEx.Value{value: 3, type: :number},\n      %FeelEx.Value{value: \"a\", type: :string},\n      %FeelEx.Value{value: \"b\", type: :string}\n    ]","title":"Examples - FeelEx.Functions.append/2","ref":"FeelEx.Functions.html#append/2-examples"},{"type":"function","doc":"Performs ceiling operation on the given number.","title":"FeelEx.Functions.ceiling/1","ref":"FeelEx.Functions.html#ceiling/1"},{"type":"function","doc":"iex> number = FeelEx.Value.new(1/3)\n    %FeelEx.Value{value: 0.3333333333333333, type: :number}\n    iex> FeelEx.Functions.ceiling(number)\n    %FeelEx.Value{value: 1, type: :number}","title":"Examples - FeelEx.Functions.ceiling/1","ref":"FeelEx.Functions.html#ceiling/1-examples"},{"type":"function","doc":"Performs ceiling operation on the given number, with a given scale.","title":"FeelEx.Functions.ceiling/2","ref":"FeelEx.Functions.html#ceiling/2"},{"type":"function","doc":"iex> number = FeelEx.Value.new(1/3)\n    %FeelEx.Value{value: 0.3333333333333333, type: :number}\n    iex> scale = FeelEx.Value.new(3)\n    %FeelEx.Value{value: 3, type: :number}\n    iex> FeelEx.Functions.ceiling(number,scale)\n    %FeelEx.Value{value: 0.334, type: :number}","title":"Examples - FeelEx.Functions.ceiling/2","ref":"FeelEx.Functions.html#ceiling/2-examples"},{"type":"function","doc":"Given a list of lists, perform concatenation.","title":"FeelEx.Functions.concatenate/1","ref":"FeelEx.Functions.html#concatenate/1"},{"type":"function","doc":"iex> list = FeelEx.Value.new([1,2,3])\n  [\n    %FeelEx.Value{value: 1, type: :number},\n    %FeelEx.Value{value: 2, type: :number},\n    %FeelEx.Value{value: 3, type: :number}\n  ]\n  iex> items = FeelEx.Value.new([[1,2],[\"a\",\"b\"]])\n  [\n  [\n    %FeelEx.Value{value: 1, type: :number},\n    %FeelEx.Value{value: 2, type: :number}\n  ],\n  [\n    %FeelEx.Value{value: \"a\", type: :string},\n    %FeelEx.Value{value: \"b\", type: :string}\n  ]\n  ]\n\n  iex> FeelEx.Functions.concatenate(items)\n  [\n    %FeelEx.Value{value: 1, type: :number},\n    %FeelEx.Value{value: 2, type: :number},\n    %FeelEx.Value{value: \"a\", type: :string},\n    %FeelEx.Value{value: \"b\", type: :string}\n  ]","title":"Examples - FeelEx.Functions.concatenate/1","ref":"FeelEx.Functions.html#concatenate/1-examples"},{"type":"function","doc":"Given a string and a match check if string contains a given match, otherwise it returns false.\n\niex> string = FeelEx.Value.new(\"Aw Dinja !!\")\n%FeelEx.Value{value: \"Aw Dinja !!\", type: :string}\niex> match = FeelEx.Value.new(\"ew\")\n%FeelEx.Value{value: \"ew\", type: :string}\niex> FeelEx.Functions.contains(string,match)\n%FeelEx.Value{value: false, type: :boolean}","title":"FeelEx.Functions.contains/2","ref":"FeelEx.Functions.html#contains/2"},{"type":"function","doc":"Constructs a FeelEx context based of a list of context where each context must contain keys:\n`key` and `value`. Returns null if the list contains a value which is not a context, or if a\ncontext, it does not contain the required keys.","title":"FeelEx.Functions.context/1","ref":"FeelEx.Functions.html#context/1"},{"type":"function","doc":"iex(79)> value = FeelEx.Value.new([%{key: \"a\", value: 1},%{key: \"b\", value: \"bee\"}])\n    [\n    %FeelEx.Value{\n      value: %{\n        value: %FeelEx.Value{value: 1, type: :number},\n        key: %FeelEx.Value{value: \"a\", type: :string}\n      },\n      type: :context\n    },\n    %FeelEx.Value{\n      value: %{\n        value: %FeelEx.Value{value: \"bee\", type: :string},\n        key: %FeelEx.Value{value: \"b\", type: :string}\n      },\n      type: :context\n    }\n    ]\n    iex(80)> FeelEx.Functions.context(value)\n    %FeelEx.Value{\n    value: %{\n      a: %FeelEx.Value{value: 1, type: :number},\n      b: %FeelEx.Value{value: \"bee\", type: :string}\n    },\n    type: :context\n    }","title":"Examples - FeelEx.Functions.context/1","ref":"FeelEx.Functions.html#context/1-examples"},{"type":"function","doc":"Returns the number of elements of the given list.","title":"FeelEx.Functions.count/1","ref":"FeelEx.Functions.html#count/1"},{"type":"function","doc":"iex> list = FeelEx.Value.new([1,2,3])\n  [\n  %FeelEx.Value{value: 1, type: :number},\n  %FeelEx.Value{value: 2, type: :number},\n  %FeelEx.Value{value: 3, type: :number}\n  ]\n  iex> FeelEx.Functions.count(list)\n  %FeelEx.Value{value: 3, type: :number}","title":"Examples - FeelEx.Functions.count/1","ref":"FeelEx.Functions.html#count/1-examples"},{"type":"function","doc":"Returns FeelEx date value from a given string. If date cannot be parsed FeelEx's null value\nis returned. For example, \"2024-06-31\" is invalid because June only contains 30 days.\n\nThis function can be used exract a date value from date-time value.","title":"FeelEx.Functions.date/1","ref":"FeelEx.Functions.html#date/1"},{"type":"function","doc":"iex> value = FeelEx.Value.new(\"2021-01-03\")\n    %FeelEx.Value{value: \"2021-01-03\", type: :string}\n    iex> FeelEx.Functions.date(value)\n    %FeelEx.Value{value: ~D[2021-01-03], type: :date}\n    iex> value = FeelEx.Value.new(NaiveDateTime.utc_now,\"+01:00\")\n    %FeelEx.Value{\n    value: {~N[2025-01-19 20:40:52.380623], \"+01:00\"},\n    type: :date_time\n    }\n    iex> FeelEx.Functions.date(value)\n    %FeelEx.Value{value: ~D[2025-01-19], type: :date}","title":"Examples - FeelEx.Functions.date/1","ref":"FeelEx.Functions.html#date/1-examples"},{"type":"function","doc":"Creates a FeelEx's date value using year, month, day components represented by FeelEx's numbers.\nIf the date components are invalid a FeelEx's null value is returned.","title":"FeelEx.Functions.date/3","ref":"FeelEx.Functions.html#date/3"},{"type":"function","doc":"iex> year = FeelEx.Value.new(2021)\n      %FeelEx.Value{value: 2021, type: :number}\n      iex> month = FeelEx.Value.new(6)\n      %FeelEx.Value{value: 6, type: :number}\n      iex> day = FeelEx.Value.new(1)\n      %FeelEx.Value{value: 1, type: :number}\n      iex)> FeelEx.Functions.date(year,month,day)\n      %FeelEx.Value{value: ~D[2021-06-01], type: :date}","title":"Examples - FeelEx.Functions.date/3","ref":"FeelEx.Functions.html#date/3-examples"},{"type":"function","doc":"Create date and time value from string.","title":"FeelEx.Functions.date_and_time/1","ref":"FeelEx.Functions.html#date_and_time/1"},{"type":"function","doc":"iex> value = FeelEx.Value.new(\"2018-04-29T09:30:00\")\n    %FeelEx.Value{value: \"2018-04-29T09:30:00\", type: :string}\n    iex> FeelEx.Functions.date_and_time(value)\n    %FeelEx.Value{value: ~N[2018-04-29 09:30:00], type: :date_time}\n    iex> value = FeelEx.Value.new(\"2018-04-29T09:30:00+02:00\")\n    %FeelEx.Value{value: \"2018-04-29T09:30:00+02:00\", type: :string}\n    iex> FeelEx.Functions.date_and_time(value)\n    %FeelEx.Value{value: {~N[2018-04-29 09:30:00], \"+02:00\"}, type: :date_time}\n    iex> value = FeelEx.Value.new(\"2018-04-29T09:30:00@Europe/Malta\")\n    %FeelEx.Value{value: \"2018-04-29T09:30:00@Europe/Malta\", type: :string}\n    iex> FeelEx.Functions.date_and_time(value)\n    %FeelEx.Value{\n    value: {~N[2018-04-29 09:30:00], \"+01:00\", \"Europe/Malta\"},\n    type: :date_time\n    }","title":"Examples - FeelEx.Functions.date_and_time/1","ref":"FeelEx.Functions.html#date_and_time/1-examples"},{"type":"function","doc":"Create date time value from date and time components.","title":"FeelEx.Functions.date_and_time/2","ref":"FeelEx.Functions.html#date_and_time/2"},{"type":"function","doc":"iex> date = FeelEx.Value.new(Date.utc_today)\n    %FeelEx.Value{value: ~D[2025-01-19], type: :date}\n    iex> date = FeelEx.Value.new(Time.utc_now)\n    %FeelEx.Value{value: ~T[21:47:33.597814], type: :time}\n    iex> date = FeelEx.Value.new(Date.utc_today)\n    %FeelEx.Value{value: ~D[2025-01-19], type: :date}\n    iex> time = FeelEx.Value.new(Time.utc_now)\n    %FeelEx.Value{value: ~T[21:47:41.988770], type: :time}\n    iex> FeelEx.Functions.date_and_time(date,time)\n    %FeelEx.Value{value: ~N[2025-01-19 21:47:41.988770], type: :date_time}\n    iex> date_time = FeelEx.Value.new(NaiveDateTime.utc_now)\n    %FeelEx.Value{value: ~N[2025-01-19 21:58:55.449808], type: :date_time}\n    iex> time = FeelEx.Value.new(Time.new!(8,2,3))\n    %FeelEx.Value{value: ~T[08:02:03], type: :time}\n    iex> FeelEx.Functions.date_and_time(date_time,time)\n    %FeelEx.Value{value: ~N[2025-01-19 08:02:03], type: :date_time}","title":"Examples - FeelEx.Functions.date_and_time/2","ref":"FeelEx.Functions.html#date_and_time/2-examples"},{"type":"function","doc":"Given a number and a scale it returns the number at the given scale.","title":"FeelEx.Functions.decimal/2","ref":"FeelEx.Functions.html#decimal/2"},{"type":"function","doc":"iex> number = FeelEx.Value.new(1/3)\n%FeelEx.Value{value: 0.3333333333333333, type: :number}\niex> scale = FeelEx.Value.new(2)\n%FeelEx.Value{value: 2, type: :number}\niex> FeelEx.Functions.decimal(number,scale)\n%FeelEx.Value{value: 0.33, type: :number}","title":"Examples - FeelEx.Functions.decimal/2","ref":"FeelEx.Functions.html#decimal/2-examples"},{"type":"function","doc":"Returns the given list without duplicates.","title":"FeelEx.Functions.distinct_values/1","ref":"FeelEx.Functions.html#distinct_values/1"},{"type":"function","doc":"iex> list  = FeelEx.Value.new([1,2,3,2,1])\n    [\n      %FeelEx.Value{value: 1, type: :number},\n      %FeelEx.Value{value: 2, type: :number},\n      %FeelEx.Value{value: 3, type: :number},\n      %FeelEx.Value{value: 2, type: :number},\n      %FeelEx.Value{value: 1, type: :number}\n    ]\n    iex> FeelEx.Functions.distinct_values(list)\n    [\n      %FeelEx.Value{value: 1, type: :number},\n      %FeelEx.Value{value: 2, type: :number},\n      %FeelEx.Value{value: 3, type: :number}\n    ]","title":"Examples - FeelEx.Functions.distinct_values/1","ref":"FeelEx.Functions.html#distinct_values/1-examples"},{"type":"function","doc":"","title":"FeelEx.Functions.duplicate_value/1","ref":"FeelEx.Functions.html#duplicate_value/1"},{"type":"function","doc":"Returns duplicate values within a list.","title":"FeelEx.Functions.duplicate_values/1","ref":"FeelEx.Functions.html#duplicate_values/1"},{"type":"function","doc":"iex> list  = FeelEx.Value.new([1,2,3,2,1])\n  [\n    %FeelEx.Value{value: 1, type: :number},\n    %FeelEx.Value{value: 2, type: :number},\n    %FeelEx.Value{value: 3, type: :number},\n    %FeelEx.Value{value: 2, type: :number},\n    %FeelEx.Value{value: 1, type: :number}\n  ]\n  iex> FeelEx.Functions.duplicate_value(list)\n  [%FeelEx.Value{value: 1, type: :number}, %FeelEx.Value{value: 2, type: :number}]","title":"Examples - FeelEx.Functions.duplicate_values/1","ref":"FeelEx.Functions.html#duplicate_values/1-examples"},{"type":"function","doc":"Creates a duration from string. FeelEx supports two types of durations:\n`days-time-duration` and `years-months-duration`. With the former containing\nday, hour, minute, and second components and the latter containing year and month components.","title":"FeelEx.Functions.duration/1","ref":"FeelEx.Functions.html#duration/1"},{"type":"function","doc":"iex> value = FeelEx.Value.new(\"P1DT1H2M\")\n  %FeelEx.Value{value: \"P1DT1H2M\", type: :string}\n  iex> FeelEx.Functions.duration(value)\n  %FeelEx.Value{\n  value: %Duration{day: 1, hour: 1, minute: 2},\n  type: :days_time_duration\n  }\n  iex> value = FeelEx.Value.new(\"P1Y1M\")\n  %FeelEx.Value{value: \"P1Y1M\", type: :string}\n  iex> FeelEx.Functions.duration(value)\n  %FeelEx.Value{value: %Duration{year: 1, month: 1}, type: :years_months_duration}","title":"Examples - FeelEx.Functions.duration/1","ref":"FeelEx.Functions.html#duration/1-examples"},{"type":"function","doc":"Given a string and a match. It returns true if the given string ends with match, otherwise it returns false.","title":"FeelEx.Functions.ends_with/2","ref":"FeelEx.Functions.html#ends_with/2"},{"type":"function","doc":"iex> string = FeelEx.Value.new(\"Aw Dinja !!\")\n    %FeelEx.Value{value: \"Aw Dinja !!\", type: :string}\n    iex> match = FeelEx.Value.new(\"Aw D\")\n    %FeelEx.Value{value: \"ja\" , type: :string}\n    iex> FeelEx.Functions.starts_with(string,match)\n    %FeelEx.Value{value: true, type: :boolean}","title":"Examples - FeelEx.Functions.ends_with/2","ref":"FeelEx.Functions.html#ends_with/2-examples"},{"type":"function","doc":"Returns true if the given number is even, otherwise returns false.","title":"FeelEx.Functions.even/1","ref":"FeelEx.Functions.html#even/1"},{"type":"function","doc":"iex> value = FeelEx.Value.new(5)\n    %FeelEx.Value{value: 5, type: :number}\n    iex> FeelEx.Functions.even(value)\n    %FeelEx.Value{value: false, type: :boolean}\n    iex> value = FeelEx.Value.new(6)\n    %FeelEx.Value{value: 6, type: :number}\n    iex> FeelEx.Functions.even(value)\n    %FeelEx.Value{value: true, type: :boolean}","title":"Examples - FeelEx.Functions.even/1","ref":"FeelEx.Functions.html#even/1-examples"},{"type":"function","doc":"Returns e raised to the power of the given number.","title":"FeelEx.Functions.exp/1","ref":"FeelEx.Functions.html#exp/1"},{"type":"function","doc":"iex> number = FeelEx.Value.new(5)\n    %FeelEx.Value{value: 5, type: :number}\n    iex> FeelEx.Functions.exp(number)\n    %FeelEx.Value{value: 148.4131591025766, type: :number}","title":"Examples - FeelEx.Functions.exp/1","ref":"FeelEx.Functions.html#exp/1-examples"},{"type":"function","doc":"","title":"FeelEx.Functions.flatten/1","ref":"FeelEx.Functions.html#flatten/1"},{"type":"function","doc":"Performs floor operation on the given number.","title":"FeelEx.Functions.floor/1","ref":"FeelEx.Functions.html#floor/1"},{"type":"function","doc":"iex> number = FeelEx.Value.new(1/3)\n    %FeelEx.Value{value: 0.3333333333333333, type: :number}\n    iex> FeelEx.Functions.floor(number)\n    %FeelEx.Value{value: 0, type: :number}","title":"Examples - FeelEx.Functions.floor/1","ref":"FeelEx.Functions.html#floor/1-examples"},{"type":"function","doc":"Performs floor operation on the given number with a given scale.","title":"FeelEx.Functions.floor/2","ref":"FeelEx.Functions.html#floor/2"},{"type":"function","doc":"iex> number = FeelEx.Value.new(1/3)\n    %FeelEx.Value{value: 0.3333333333333333, type: :number}\n    iex> scale = FeelEx.Value.new(3)\n    %FeelEx.Value{value: 3, type: :number}\n    iex> FeelEx.Functions.floor(number,scale)\n    %FeelEx.Value{value: 0.333, type: :number}","title":"Examples - FeelEx.Functions.floor/2","ref":"FeelEx.Functions.html#floor/2-examples"},{"type":"function","doc":"Returns 1-based indices of a given list corresponding to a given match.","title":"FeelEx.Functions.index_of/2","ref":"FeelEx.Functions.html#index_of/2"},{"type":"function","doc":"iex> list  = FeelEx.Value.new([1,2,3,2])\n    [\n    %FeelEx.Value{value: 1, type: :number},\n    %FeelEx.Value{value: 2, type: :number},\n    %FeelEx.Value{value: 3, type: :number},\n    %FeelEx.Value{value: 2, type: :number}\n    ]\n    iex> value = FeelEx.Value.new(2)\n    %FeelEx.Value{value: 2, type: :number}\n    iex> FeelEx.Functions.index_of(list,value)\n    [%FeelEx.Value{value: 2, type: :number}, %FeelEx.Value{value: 4, type: :number}]","title":"Examples - FeelEx.Functions.index_of/2","ref":"FeelEx.Functions.html#index_of/2-examples"},{"type":"function","doc":"Returns the given list with newItem inserted at position.","title":"FeelEx.Functions.insert_before/3","ref":"FeelEx.Functions.html#insert_before/3"},{"type":"function","doc":"iex> list  = FeelEx.Value.new([1,3])\n    [%FeelEx.Value{value: 1, type: :number}, %FeelEx.Value{value: 3, type: :number}]\n    iex> position = FeelEx.Value.new(1)\n    %FeelEx.Value{value: 1, type: :number}\n    iex> value = FeelEx.Value.new(2)\n    %FeelEx.Value{value: 2, type: :number}\n    iex> FeelEx.Functions.insert_before(list,position,value)\n    [\n      %FeelEx.Value{value: 2, type: :number},\n      %FeelEx.Value{value: 1, type: :number},\n      %FeelEx.Value{value: 3, type: :number}\n    ]","title":"Examples - FeelEx.Functions.insert_before/3","ref":"FeelEx.Functions.html#insert_before/3-examples"},{"type":"function","doc":"Returns true if the given list is empty. Otherwise, returns false.","title":"FeelEx.Functions.is_empty/1","ref":"FeelEx.Functions.html#is_empty/1"},{"type":"function","doc":"iex> list  = FeelEx.Value.new([])\n[]\niex> FeelEx.Functions.is_empty(list)\n%FeelEx.Value{value: true, type: :boolean}\niex> list  = FeelEx.Value.new([1,2,3])\n[\n%FeelEx.Value{value: 1, type: :number},\n%FeelEx.Value{value: 2, type: :number},\n%FeelEx.Value{value: 3, type: :number}\n]\niex> FeelEx.Functions.is_empty(list)\n%FeelEx.Value{value: false, type: :boolean}","title":"Examples - FeelEx.Functions.is_empty/1","ref":"FeelEx.Functions.html#is_empty/1-examples"},{"type":"function","doc":"Checks if list contains some value.","title":"FeelEx.Functions.list_contains/2","ref":"FeelEx.Functions.html#list_contains/2"},{"type":"function","doc":"iex> list = FeelEx.Value.new([1,2,3])\n    [\n    %FeelEx.Value{value: 1, type: :number},\n    %FeelEx.Value{value: 2, type: :number},\n    %FeelEx.Value{value: 3, type: :number}\n    ]\n    iex> member = FeelEx.Value.new(1)\n    %FeelEx.Value{value: 1, type: :number}\n    iex> FeelEx.Functions.list_contains(list,member)\n    %FeelEx.Value{value: true, type: :boolean}","title":"Examples - FeelEx.Functions.list_contains/2","ref":"FeelEx.Functions.html#list_contains/2-examples"},{"type":"function","doc":"Returns natural logarithm (base e) of the given number.","title":"FeelEx.Functions.log/1","ref":"FeelEx.Functions.html#log/1"},{"type":"function","doc":"iex> number = FeelEx.Value.new(10)\n    %FeelEx.Value{value: 10, type: :number}\n    iex> FeelEx.Functions.log(number)\n    %FeelEx.Value{value: 2.302585092994046, type: :number}","title":"Examples - FeelEx.Functions.log/1","ref":"FeelEx.Functions.html#log/1-examples"},{"type":"function","doc":"Transforms every character in a given string into upper case.","title":"FeelEx.Functions.lower_case/1","ref":"FeelEx.Functions.html#lower_case/1"},{"type":"function","doc":"iex> string = FeelEx.Value.new(\"Aw Dinja !!\")\n  %FeelEx.Value{value: \"Aw Dinja !!\", type: :string}\n  iex> FeelEx.Functions.upper_case(string)\n  %FeelEx.Value{value: \"aw dinja !!\", type: :string}","title":"Examples - FeelEx.Functions.lower_case/1","ref":"FeelEx.Functions.html#lower_case/1-examples"},{"type":"function","doc":"Returns the maximum, in a list. All elements in the list should have the same type and\nbe comparable.","title":"FeelEx.Functions.max/1","ref":"FeelEx.Functions.html#max/1"},{"type":"function","doc":"iex> list = FeelEx.Value.new([2,4,1,2])\n    [\n    %FeelEx.Value{value: 2, type: :number},\n    %FeelEx.Value{value: 4, type: :number},\n    %FeelEx.Value{value: 1, type: :number},\n    %FeelEx.Value{value: 2, type: :number}\n    ]\n    iex> FeelEx.Functions.max(list)\n    %FeelEx.Value{value: 4, type: :number}","title":"Examples - FeelEx.Functions.max/1","ref":"FeelEx.Functions.html#max/1-examples"},{"type":"function","doc":"Returns arithmetic mean given a list of numbers.\nReturns nil when the list is empty or contains an element which is not a number.","title":"FeelEx.Functions.mean/1","ref":"FeelEx.Functions.html#mean/1"},{"type":"function","doc":"iex> list = FeelEx.Value.new([1,2,3])\n    [\n    %FeelEx.Value{value: 1, type: :number},\n    %FeelEx.Value{value: 2, type: :number},\n    %FeelEx.Value{value: 3, type: :number}\n    ]\n    iex> FeelEx.Functions.mean(list)\n    %FeelEx.Value{value: 2, type: :number}","title":"Examples - FeelEx.Functions.mean/1","ref":"FeelEx.Functions.html#mean/1-examples"},{"type":"function","doc":"Returns the median element of the given list of numbers.","title":"FeelEx.Functions.median/1","ref":"FeelEx.Functions.html#median/1"},{"type":"function","doc":"iex> value = FeelEx.Value.new([6, 1, 2, 3])\n    [\n      %FeelEx.Value{value: 6, type: :number},\n      %FeelEx.Value{value: 1, type: :number},\n      %FeelEx.Value{value: 2, type: :number},\n      %FeelEx.Value{value: 3, type: :number}\n    ]\n    iex> FeelEx.Functions.median(value)\n    %FeelEx.Value{value: 2.5, type: :number}","title":"Examples - FeelEx.Functions.median/1","ref":"FeelEx.Functions.html#median/1-examples"},{"type":"function","doc":"Returns the minimum in a list. All elements in the list should have the same type and\nbe comparable.","title":"FeelEx.Functions.min/1","ref":"FeelEx.Functions.html#min/1"},{"type":"function","doc":"iex> list = FeelEx.Value.new([2,4,1,2])\n    [\n    %FeelEx.Value{value: 2, type: :number},\n    %FeelEx.Value{value: 4, type: :number},\n    %FeelEx.Value{value: 1, type: :number},\n    %FeelEx.Value{value: 2, type: :number}\n    ]\n    iex> FeelEx.Functions.min(list)\n    %FeelEx.Value{value: 1, type: :number}\n    iex> list = FeelEx.Value.new([2,4,1,\"a\"])\n    [\n    %FeelEx.Value{value: 2, type: :number},\n    %FeelEx.Value{value: 4, type: :number},\n    %FeelEx.Value{value: 1, type: :number},\n    %FeelEx.Value{value: \"a\", type: :string}\n    ]\n    iex> FeelEx.Functions.min(list)\n    [warning] [Elixir.FeelEx.Functions][min/1] Failed to invoke function 'min': [%FeelEx.Value{value: 2, type: :number}, %FeelEx.Value{value: 4, type: :number}, %FeelEx.Value{value: 1, type: :number}, %FeelEx.Value{value: \"a\", type: :string}] is not comparable\n    %FeelEx.Value{value: nil, type: :null}","title":"Examples - FeelEx.Functions.min/1","ref":"FeelEx.Functions.html#min/1-examples"},{"type":"function","doc":"Returns the mode of the given list of numbers.","title":"FeelEx.Functions.mode/1","ref":"FeelEx.Functions.html#mode/1"},{"type":"function","doc":"iex> value = FeelEx.Value.new([6, 1, 9, 6, 1])\n    [\n      %FeelEx.Value{value: 6, type: :number},\n      %FeelEx.Value{value: 1, type: :number},\n      %FeelEx.Value{value: 9, type: :number},\n      %FeelEx.Value{value: 6, type: :number},\n      %FeelEx.Value{value: 1, type: :number}\n    ]\n    iex> FeelEx.Functions.mode(value)\n    [%FeelEx.Value{value: 1, type: :number}, %FeelEx.Value{value: 6, type: :number}]","title":"Examples - FeelEx.Functions.mode/1","ref":"FeelEx.Functions.html#mode/1-examples"},{"type":"function","doc":"Returns the remainder returned by division of the divedend by the divisor.","title":"FeelEx.Functions.modulo/2","ref":"FeelEx.Functions.html#modulo/2"},{"type":"function","doc":"iex> number = FeelEx.Value.new(12)\n    %FeelEx.Value{value: 12, type: :number}\n    iex> scale = FeelEx.Value.new(5)\n    %FeelEx.Value{value: 5, type: :number}\n    iex> FeelEx.Functions.modulo(number,scale)\n    %FeelEx.Value{value: 2, type: :number}","title":"Examples - FeelEx.Functions.modulo/2","ref":"FeelEx.Functions.html#modulo/2-examples"},{"type":"function","doc":"Negates a value of type boolean. Returns null on other type of values","title":"FeelEx.Functions.negate/1","ref":"FeelEx.Functions.html#negate/1"},{"type":"function","doc":"iex> value = FeelEx.Value.new(true)\n    %FeelEx.Value{value: true, type: :boolean}\n    iex> FeelEx.Functions.negate(value)\n    %FeelEx.Value{value: false, type: :boolean}","title":"Examples - FeelEx.Functions.negate/1","ref":"FeelEx.Functions.html#negate/1-examples"},{"type":"function","doc":"Parses a given FeelEx value of type string to a FeelEx value of type integer.\nReturns FeelEx null value if the string is not a number.","title":"FeelEx.Functions.number/1","ref":"FeelEx.Functions.html#number/1"},{"type":"function","doc":"iex> value = FeelEx.Value.new(\"21\")\n    %FeelEx.Value{value: \"21\", type: :string}\n    iex> FeelEx.Functions.number(value)\n    %FeelEx.Value{value: 21, type: :number}\n    iex> value = FeelEx.Value.new(\"21.69\")\n    %FeelEx.Value{value: \"21.69\", type: :string}\n    iex> FeelEx.Functions.number(value)\n    %FeelEx.Value{value: 21.69, type: :number}\n    iex> value = FeelEx.Value.new(\"21.69wazzup\")\n    %FeelEx.Value{value: \"21.69wazzup\", type: :string}\n    iex> FeelEx.Functions.number(value)\n    %FeelEx.Value{value: nil, type: :null}","title":"Examples - FeelEx.Functions.number/1","ref":"FeelEx.Functions.html#number/1-examples"},{"type":"function","doc":"Returns true if the given number is odd, otherwise returns false.","title":"FeelEx.Functions.odd/1","ref":"FeelEx.Functions.html#odd/1"},{"type":"function","doc":"iex> value = FeelEx.Value.new(5)\n    %FeelEx.Value{value: 5, type: :number}\n    iex> FeelEx.Functions.odd(value)\n    %FeelEx.Value{value: true, type: :boolean}\n    iex> value = FeelEx.Value.new(6)\n    %FeelEx.Value{value: 6, type: :number}\n    iex> FeelEx.Functions.odd(value)\n    %FeelEx.Value{value: false, type: :boolean}","title":"Examples - FeelEx.Functions.odd/1","ref":"FeelEx.Functions.html#odd/1-examples"},{"type":"function","doc":"Returns the product of the given list of numbers.","title":"FeelEx.Functions.product/1","ref":"FeelEx.Functions.html#product/1"},{"type":"function","doc":"iex > list = FeelEx.Value.new([2,4,1,2])\n[\n%FeelEx.Value{value: 2, type: :number},\n%FeelEx.Value{value: 4, type: :number},\n%FeelEx.Value{value: 1, type: :number},\n%FeelEx.Value{value: 2, type: :number}\n]\niex > FeelEx.Functions.product(list)\n%FeelEx.Value{value: 16, type: :number}","title":"Examples - FeelEx.Functions.product/1","ref":"FeelEx.Functions.html#product/1-examples"},{"type":"function","doc":"Returns a number between 0 and 1.","title":"FeelEx.Functions.random/0","ref":"FeelEx.Functions.html#random/0"},{"type":"function","doc":"iex> FeelEx.Functions.random()\n    %FeelEx.Value{value: 0.5189989081813825, type: :number}","title":"Examples - FeelEx.Functions.random/0","ref":"FeelEx.Functions.html#random/0-examples"},{"type":"function","doc":"Returns the given list without the element at position.","title":"FeelEx.Functions.remove/2","ref":"FeelEx.Functions.html#remove/2"},{"type":"function","doc":"iex> list  = FeelEx.Value.new([1,2,3])\n    [\n    %FeelEx.Value{value: 1, type: :number},\n    %FeelEx.Value{value: 2, type: :number},\n    %FeelEx.Value{value: 3, type: :number}\n    ]\n    iex> position = FeelEx.Value.new(2)\n    %FeelEx.Value{value: 2, type: :number}\n    iex> FeelEx.Functions.remove(list,position)\n    [%FeelEx.Value{value: 1, type: :number}, %FeelEx.Value{value: 3, type: :number}]","title":"Examples - FeelEx.Functions.remove/2","ref":"FeelEx.Functions.html#remove/2-examples"},{"type":"function","doc":"Returns the given list in revered order.","title":"FeelEx.Functions.reverse/1","ref":"FeelEx.Functions.html#reverse/1"},{"type":"function","doc":"iex> list  = FeelEx.Value.new([1,3])\n[%FeelEx.Value{value: 1, type: :number}, %FeelEx.Value{value: 3, type: :number}]\niex> FeelEx.Functions.reverse(list)\n[%FeelEx.Value{value: 3, type: :number}, %FeelEx.Value{value: 1, type: :number}]","title":"Examples - FeelEx.Functions.reverse/1","ref":"FeelEx.Functions.html#reverse/1-examples"},{"type":"function","doc":"Rounds down a given number with a given scale.","title":"FeelEx.Functions.round_down/2","ref":"FeelEx.Functions.html#round_down/2"},{"type":"function","doc":"iex> number = FeelEx.Value.new(5.5)\n    %FeelEx.Value{value: 5.5, type: :number}\n    iex> scale = FeelEx.Value.new(0)\n    %FeelEx.Value{value: 0, type: :number}\n    iex> FeelEx.Functions.round_down(number,scale)\n    %FeelEx.Value{value: 5, type: :number}","title":"Examples - FeelEx.Functions.round_down/2","ref":"FeelEx.Functions.html#round_down/2-examples"},{"type":"function","doc":"Rounds a number using round-half-up mode.","title":"FeelEx.Functions.round_half_down/2","ref":"FeelEx.Functions.html#round_half_down/2"},{"type":"function","doc":"iex> number = FeelEx.Value.new(5.5)\n    %FeelEx.Value{value: 5.5, type: :number}\n    iex> scale = FeelEx.Value.new(0)\n    %FeelEx.Value{value: 0, type: :number}\n    iex> FeelEx.Functions.round_half_down(number,scale)\n    %FeelEx.Value{value: 5, type: :number}\n    iex> number = FeelEx.Value.new(-5.5)\n    %FeelEx.Value{value: -5.5, type: :number}\n    iex> scale = FeelEx.Value.new(0)\n    %FeelEx.Value{value: 0, type: :number}\n    iex> FeelEx.Functions.round_half_down(number,scale)\n    %FeelEx.Value{value: -5, type: :number}\n    iex> number = FeelEx.Value.new(1.121)\n    %FeelEx.Value{value: 1.121, type: :number}\n    iex> scale = FeelEx.Value.new(2)\n    %FeelEx.Value{value: 2, type: :number}\n    iex> FeelEx.Functions.round_half_down(number,scale)\n    %FeelEx.Value{value: 1.12, type: :number}\n    iex> number = FeelEx.Value.new(-1.126)\n    %FeelEx.Value{value: -1.126, type: :number}\n    iex> scale = FeelEx.Value.new(2)\n    %FeelEx.Value{value: 2, type: :number}\n    iex> FeelEx.Functions.round_half_down(number,scale)\n    %FeelEx.Value{value: -1.13, type: :number}","title":"Examples - FeelEx.Functions.round_half_down/2","ref":"FeelEx.Functions.html#round_half_down/2-examples"},{"type":"function","doc":"Rounds a number using round-half-up mode.","title":"FeelEx.Functions.round_half_up/2","ref":"FeelEx.Functions.html#round_half_up/2"},{"type":"function","doc":"iex> number = FeelEx.Value.new(5.5)\n    %FeelEx.Value{value: 5.5, type: :number}\n    iex> scale = FeelEx.Value.new(0)\n    %FeelEx.Value{value: 0, type: :number}\n    iex> FeelEx.Functions.round_half_up(number,scale)\n    %FeelEx.Value{value: 6, type: :number}\n    iex> number = FeelEx.Value.new(-5.5)\n    %FeelEx.Value{value: -5.5, type: :number}\n    iex> scale = FeelEx.Value.new(0)\n    %FeelEx.Value{value: 0, type: :number}\n    iex> FeelEx.Functions.round_half_up(number,scale)\n    %FeelEx.Value{value: -6, type: :number}\n    iex> number = FeelEx.Value.new(1.121)\n    %FeelEx.Value{value: 1.121, type: :number}\n    iex> scale = FeelEx.Value.new(2)\n    %FeelEx.Value{value: 2, type: :number}\n    iex> FeelEx.Functions.round_half_up(number,scale)\n    %FeelEx.Value{value: 1.12, type: :number}\n    iex> number = FeelEx.Value.new(-1.126)\n    %FeelEx.Value{value: -1.126, type: :number}\n    iex> scale = FeelEx.Value.new(2)\n    %FeelEx.Value{value: 2, type: :number}\n    iex> FeelEx.Functions.round_half_up(number,scale)\n    %FeelEx.Value{value: -1.13, type: :number}","title":"Examples - FeelEx.Functions.round_half_up/2","ref":"FeelEx.Functions.html#round_half_up/2-examples"},{"type":"function","doc":"Rounds up a given number with a given scale.","title":"FeelEx.Functions.round_up/2","ref":"FeelEx.Functions.html#round_up/2"},{"type":"function","doc":"iex> number = FeelEx.Value.new(1/3)\n    %FeelEx.Value{value: 0.3333333333333333, type: :number}\n    iex> scale = FeelEx.Value.new(0)\n    %FeelEx.Value{value: 0, type: :number}\n    iex> FeelEx.Functions.round_up(number,scale)\n    %FeelEx.Value{value: 1, type: :number}\n    iex> number = FeelEx.Value.new(1.121)\n    %FeelEx.Value{value: 1.121, type: :number}\n    iex> scale = FeelEx.Value.new(2)\n    %FeelEx.Value{value: 2, type: :number}\n    iex> FeelEx.Functions.round_up(number,scale)\n    %FeelEx.Value{value: 1.13, type: :number}\n    iex number = FeelEx.Value.new(-1.126)\n    %FeelEx.Value{value: -1.126, type: :number}\n    iex scale = FeelEx.Value.new(2)\n    %FeelEx.Value{value: 2, type: :number}\n    iex> FeelEx.Functions.round_up(number,scale)\n    %FeelEx.Value{value: -1.13, type: :number}","title":"Examples - FeelEx.Functions.round_up/2","ref":"FeelEx.Functions.html#round_up/2-examples"},{"type":"function","doc":"Given a string and delimeter it splits string into a list of string,\nbreaking at each occurence of delimeter","title":"FeelEx.Functions.split/2","ref":"FeelEx.Functions.html#split/2"},{"type":"function","doc":"iex> FeelEx.evaluate(\"split(\"Hello World\",\" \")\")\n    [\n      %FeelEx.Value{value: \"Hello\", type: :string},\n      %FeelEx.Value{value: \"World\", type: :string}\n    ]","title":"Examples - FeelEx.Functions.split/2","ref":"FeelEx.Functions.html#split/2-examples"},{"type":"function","doc":"Returns the square root of the given value.","title":"FeelEx.Functions.sqrt/1","ref":"FeelEx.Functions.html#sqrt/1"},{"type":"function","doc":"iex> number = FeelEx.Value.new(16)\n    %FeelEx.Value{value: 16, type: :number}\n    iex> FeelEx.Functions.sqrt(number)\n    %FeelEx.Value{value: 4, type: :number}","title":"Examples - FeelEx.Functions.sqrt/1","ref":"FeelEx.Functions.html#sqrt/1-examples"},{"type":"function","doc":"Given a string and a match. It returns true if the given string starts with match, otherwise it returns false.","title":"FeelEx.Functions.starts_with/2","ref":"FeelEx.Functions.html#starts_with/2"},{"type":"function","doc":"iex> string = FeelEx.Value.new(\"Aw Dinja !!\")\n    %FeelEx.Value{value: \"Aw Dinja !!\", type: :string}\n    iex> match = FeelEx.Value.new(\"Aw D\")\n    %FeelEx.Value{value: \"Aw D\", type: :string}\n    iex> FeelEx.Functions.starts_with(string,match)\n    %FeelEx.Value{value: true, type: :boolean}","title":"Examples - FeelEx.Functions.starts_with/2","ref":"FeelEx.Functions.html#starts_with/2-examples"},{"type":"function","doc":"Returns the standard deviation of the given list of numbers.","title":"FeelEx.Functions.stddev/1","ref":"FeelEx.Functions.html#stddev/1"},{"type":"function","doc":"iex> value = FeelEx.Value.new([2, 4, 7, 5])\n[\n  %FeelEx.Value{value: 2, type: :number},\n  %FeelEx.Value{value: 4, type: :number},\n  %FeelEx.Value{value: 7, type: :number},\n  %FeelEx.Value{value: 5, type: :number}\n]\niex> FeelEx.Functions.stddev(value)\n%FeelEx.Value{value: 2.0816659994661326, type: :number}","title":"Examples - FeelEx.Functions.stddev/1","ref":"FeelEx.Functions.html#stddev/1-examples"},{"type":"function","doc":"Returns any FeelEx value as a FeelEx value of type string.","title":"FeelEx.Functions.string/1","ref":"FeelEx.Functions.html#string/1"},{"type":"function","doc":"iex> value = FeelEx.Value.new(1.1)\n    %FeelEx.Value{value: 1.1, type: :number}\n    iex> FeelEx.Functions.string(value)\n    %FeelEx.Value{value: \"1.1\", type: :string}\n    iex> value = FeelEx.Value.new([1,2])\n    [%FeelEx.Value{value: 1, type: :number}, %FeelEx.Value{value: 2, type: :number}]\n    iex> FeelEx.Functions.string(value)\n    %FeelEx.Value{value: \"[1, 2]\", type: :string}","title":"Examples - FeelEx.Functions.string/1","ref":"FeelEx.Functions.html#string/1-examples"},{"type":"function","doc":"Joins a list of strings into a single string.","title":"FeelEx.Functions.string_join/1","ref":"FeelEx.Functions.html#string_join/1"},{"type":"function","doc":"iex> list  = FeelEx.Value.new([\"a\",\"b\",\"c\"])\n    [\n      %FeelEx.Value{value: \"a\", type: :string},\n      %FeelEx.Value{value: \"b\", type: :string},\n      %FeelEx.Value{value: \"c\", type: :string}\n    ]\n    iex> FeelEx.Functions.string_join(list)\n    %FeelEx.Value{value: \"abc\", type: :string}\n    iex> list  = FeelEx.Value.new([\"a\",nil,\"c\"])\n    [\n      %FeelEx.Value{value: \"a\", type: :string},\n      %FeelEx.Value{value: nil, type: :null},\n      %FeelEx.Value{value: \"c\", type: :string}\n    ]\n    iex> FeelEx.Functions.string_join(list)\n    %FeelEx.Value{value: \"ac\", type: :string}","title":"Examples - FeelEx.Functions.string_join/1","ref":"FeelEx.Functions.html#string_join/1-examples"},{"type":"function","doc":"Joins a list of strings into a single string, with a delimeter between eech element.","title":"FeelEx.Functions.string_join/2","ref":"FeelEx.Functions.html#string_join/2"},{"type":"function","doc":"iex)> list  = FeelEx.Value.new([\"a\"])\n[%FeelEx.Value{value: \"a\", type: :string}]\niex)> delimiter  = FeelEx.Value.new(\"X\")\n%FeelEx.Value{value: \"X\", type: :string}\niex)> FeelEx.Functions.string_join(list,delimiter)\n%FeelEx.Value{value: \"a\", type: :string}\niex> list  = FeelEx.Value.new([\"a\",\"b\",\"c\"])\n[\n  %FeelEx.Value{value: \"a\", type: :string},\n  %FeelEx.Value{value: \"b\", type: :string},\n  %FeelEx.Value{value: \"c\", type: :string}\n]\niex> delimiter  = FeelEx.Value.new(\", \")\n%FeelEx.Value{value: \", \", type: :string}\niex> FeelEx.Functions.string_join(list,delimiter)\n%FeelEx.Value{value: \"a, b, c\", type: :string}","title":"Examples - FeelEx.Functions.string_join/2","ref":"FeelEx.Functions.html#string_join/2-examples"},{"type":"function","doc":"Returns length of a given string.","title":"FeelEx.Functions.string_length/1","ref":"FeelEx.Functions.html#string_length/1"},{"type":"function","doc":"iex> string = FeelEx.Value.new(\"Aw dinja\")\n    %FeelEx.Value{value: \"Aw dinja\", type: :string}\n    iex> FeelEx.Functions.string_length(string)\n    %FeelEx.Value{value: 8, type: :number}","title":"Examples - FeelEx.Functions.string_length/1","ref":"FeelEx.Functions.html#string_length/1-examples"},{"type":"function","doc":"","title":"FeelEx.Functions.string_transformation/1","ref":"FeelEx.Functions.html#string_transformation/1"},{"type":"function","doc":"Returns a partial list of the given value starting at start position.","title":"FeelEx.Functions.sublist/2","ref":"FeelEx.Functions.html#sublist/2"},{"type":"function","doc":"iex> value = FeelEx.Value.new([1,2,3])\n    [\n      %FeelEx.Value{value: 1, type: :number},\n      %FeelEx.Value{value: 2, type: :number},\n      %FeelEx.Value{value: 3, type: :number}\n    ]\n    iex> start_index = FeelEx.Value.new(2)\n    %FeelEx.Value{value: 2, type: :number}\n    iex> FeelEx.Functions.sublist(value,start_index)\n    [%FeelEx.Value{value: 2, type: :number}, %FeelEx.Value{value: 3, type: :number}]","title":"Examples - FeelEx.Functions.sublist/2","ref":"FeelEx.Functions.html#sublist/2-examples"},{"type":"function","doc":"Returns a partial list of the given value starting at start position. The maximum length of the sublist returned is max_length.","title":"FeelEx.Functions.sublist/3","ref":"FeelEx.Functions.html#sublist/3"},{"type":"function","doc":"iex> value = FeelEx.Value.new([1,2,3])\n    [\n      %FeelEx.Value{value: 1, type: :number},\n      %FeelEx.Value{value: 2, type: :number},\n      %FeelEx.Value{value: 3, type: :number}\n    ]\n    iex> length = FeelEx.Value.new(2)\n    %FeelEx.Value{value: 2, type: :number}\n    iex> start_index = FeelEx.Value.new(1)\n    %FeelEx.Value{value: 1, type: :number}\n    iex> FeelEx.Functions.sublist(value,start_index,length)\n    [%FeelEx.Value{value: 1, type: :number}, %FeelEx.Value{value: 2, type: :number}]","title":"Examples - FeelEx.Functions.sublist/3","ref":"FeelEx.Functions.html#sublist/3-examples"},{"type":"function","doc":"Returns a substring of string using 1-based indexing.","title":"FeelEx.Functions.substring/2","ref":"FeelEx.Functions.html#substring/2"},{"type":"function","doc":"```\n    iex> string = FeelEx.Value.new(\"Aw dinja\")\n    %FeelEx.Value{value: \"Aw dinja\", type: :string}\n    iex> index = FeelEx.Value.new(4)\n    %FeelEx.Value{value: 4, type: :number}\n    iex> FeelEx.Functions.substring(string,index)\n    %FeelEx.Value{value: \"dinja\", type: :string}\n```","title":"Examples - FeelEx.Functions.substring/2","ref":"FeelEx.Functions.html#substring/2-examples"},{"type":"function","doc":"Returns a substring of specified length of string using 1-based indexing.","title":"FeelEx.Functions.substring/3","ref":"FeelEx.Functions.html#substring/3"},{"type":"function","doc":"iex> string = FeelEx.Value.new(\"Aw dinja\")\n      %FeelEx.Value{value: \"Aw dinja\", type: :string}\n      iex> index = FeelEx.Value.new(4)\n      %FeelEx.Value{value: 4, type: :number}\n      iex> length = FeelEx.Value.new(2)\n      %FeelEx.Value{value: 2, type: :number}\n      iex> FeelEx.Functions.substring(string,index,length)\n      %FeelEx.Value{value: \"di\", type: :string}\n```\n    iex> string = FeelEx.Value.new(\"Aw dinja\")\n    %FeelEx.Value{value: \"Aw dinja\", type: :string}\n    iex> index = FeelEx.Value.new(4)\n    %FeelEx.Value{value: 4, type: :number}\n    iex> FeelEx.Functions.substring(string,index)\n    %FeelEx.Value{value: \"dinja\", type: :string}\n```","title":"Examples - FeelEx.Functions.substring/3","ref":"FeelEx.Functions.html#substring/3-examples"},{"type":"function","doc":"Given a string and a match it returns all the characters before match.","title":"FeelEx.Functions.substring_after/2","ref":"FeelEx.Functions.html#substring_after/2"},{"type":"function","doc":"iex> string = FeelEx.Value.new(\"Aw Dinja !!\")\n    %FeelEx.Value{value: \"Aw Dinja !!\", type: :string}\n    iex> match = FeelEx.Value.new(\" Di\")\n    %FeelEx.Value{value: \" Di\", type: :string}\n    iex> FeelEx.Functions.substring_after(string,match)\n    %FeelEx.Value{value: \"nja !!\", type: :string}","title":"Examples - FeelEx.Functions.substring_after/2","ref":"FeelEx.Functions.html#substring_after/2-examples"},{"type":"function","doc":"Given a string and a match it returns all the characters before match.","title":"FeelEx.Functions.substring_before/2","ref":"FeelEx.Functions.html#substring_before/2"},{"type":"function","doc":"iex> string = FeelEx.Value.new(\"Aw Dinja !!\")\n    %FeelEx.Value{value: \"Aw Dinja !!\", type: :string}\n    iex> match = FeelEx.Value.new(\" Di\")\n    %FeelEx.Value{value: \" Di\", type: :string}\n    iex> FeelEx.Functions.substring_before(string,match)\n    %FeelEx.Value{value: \"Aw\", type: :string}","title":"Examples - FeelEx.Functions.substring_before/2","ref":"FeelEx.Functions.html#substring_before/2-examples"},{"type":"function","doc":"Returns the sum of the given list of numbers.","title":"FeelEx.Functions.sum/1","ref":"FeelEx.Functions.html#sum/1"},{"type":"function","doc":"iex> list = FeelEx.Value.new([2,4,1,2])\n    [\n      %FeelEx.Value{value: 2, type: :number},\n      %FeelEx.Value{value: 4, type: :number},\n      %FeelEx.Value{value: 1, type: :number},\n      %FeelEx.Value{value: 2, type: :number}\n    ]\n    iex> FeelEx.Functions.sum(list)\n    %FeelEx.Value{value: 9, type: :number}\n    iex> FeelEx.Functions.sum(list)\n    [warning] [Elixir.FeelEx.Functions][sum/1] Failed to invoke function 'sum': expected number but found '%FeelEx.Value{value: \"a\", type: :string}'\n    %FeelEx.Value{value: nil, type: :null}","title":"Examples - FeelEx.Functions.sum/1","ref":"FeelEx.Functions.html#sum/1-examples"},{"type":"function","doc":"Returns FeelEx time value from a given string. If time cannot be parsed FeelEx's null value\nis returned.\n\nThis function can be used exract a time value from date-time value.","title":"FeelEx.Functions.time/1","ref":"FeelEx.Functions.html#time/1"},{"type":"function","doc":"iex> value = FeelEx.Value.new(\"08:02:01\")\n    %FeelEx.Value{value: \"08:02:01\", type: :string}\n    iex> FeelEx.Functions.time(value)\n    %FeelEx.Value{value: ~T[08:02:01], type: :time}\n    iex> value = FeelEx.Value.new(\"08:02:01+02:00\")\n    %FeelEx.Value{value: \"08:02:01+02:00\", type: :string}\n    iex> FeelEx.Functions.time(value)\n    %FeelEx.Value{value: {~T[08:02:01], \"+02:00\"}, type: :time}\n    iex> value = FeelEx.Value.new(\"08:02:01@Europe/Malta\")\n    %FeelEx.Value{value: \"08:02:01@Europe/Malta\", type: :string}\n    iex> FeelEx.Functions.time(value)\n    %FeelEx.Value{value: {~T[08:02:01], \"+01:00\", \"Europe/Malta\"}, type: :time}\n    iex> value = FeelEx.Value.new(NaiveDateTime.utc_now,\"+01:00\")\n    %FeelEx.Value{\n    value: {~N[2025-01-19 20:50:37.065020], \"+01:00\"},\n    type: :date_time\n    }\n    iex> value = FeelEx.Value.new(NaiveDateTime.utc_now,\"+01:00\")\n    %FeelEx.Value{\n    value: {~N[2025-01-19 20:50:48.964545], \"+01:00\"},\n    type: :date_time\n    }\n    iex> FeelEx.Functions.date(value)\n    %FeelEx.Value{value: ~D[2025-01-19], type: :date}\n    iex> FeelEx.Functions.time(value)\n    %FeelEx.Value{value: ~T[20:50:48.964545], type: :time}","title":"Examples - FeelEx.Functions.time/1","ref":"FeelEx.Functions.html#time/1-examples"},{"type":"function","doc":"Create a FeelEx's time value using hour, minute and second component.","title":"FeelEx.Functions.time/3","ref":"FeelEx.Functions.html#time/3"},{"type":"function","doc":"iex> hour = FeelEx.Value.new(8)\n    %FeelEx.Value{value: 8, type: :number}\n    iex> minute = FeelEx.Value.new(16)\n    %FeelEx.Value{value: 16, type: :number}\n    iex> second = FeelEx.Value.new(3)\n    %FeelEx.Value{value: 3, type: :number}\n    iex> FeelEx.Functions.time(hour,minute,second)\n    %FeelEx.Value{value: ~T[08:16:03], type: :time}","title":"Examples - FeelEx.Functions.time/3","ref":"FeelEx.Functions.html#time/3-examples"},{"type":"function","doc":"Create time with hour, minute offset, time and duration FeelEx's components.","title":"FeelEx.Functions.time/4","ref":"FeelEx.Functions.html#time/4"},{"type":"function","doc":"iex>  hour = FeelEx.Value.new(8)\n    %FeelEx.Value{value: 8, type: :number}\n    iex> minute = FeelEx.Value.new(16)\n    %FeelEx.Value{value: 16, type: :number}\n    iex> second = FeelEx.Value.new(3)\n    %FeelEx.Value{value: 3, type: :number}\n    iex> duration = FeelEx.Value.new(Duration.new!(hour: 1, minute: 32))\n    %FeelEx.Value{value: %Duration{hour: 1, minute: 32}, type: :days_time_duration}\n    iex> FeelEx.Functions.time(hour,minute,second,duration)\n    %FeelEx.Value{value: {~T[08:16:03], \"+01:32\"}, type: :time}","title":"Examples - FeelEx.Functions.time/4","ref":"FeelEx.Functions.html#time/4-examples"},{"type":"function","doc":"Remove leading and trailing spaces from string","title":"FeelEx.Functions.trim/1","ref":"FeelEx.Functions.html#trim/1"},{"type":"function","doc":"iex> string = FeelEx.Value.new(\"         Aw Dinja !!       \")\n    %FeelEx.Value{value: \"         Aw Dinja !!       \", type: :string}\n    iex> FeelEx.Functions.trim(string)\n    %FeelEx.Value{value: \"Aw Dinja !!\", type: :string}","title":"Examples - FeelEx.Functions.trim/1","ref":"FeelEx.Functions.html#trim/1-examples"},{"type":"function","doc":"Returns a list that includes all elements of the given lists without duplicates.\n    iex> list  = FeelEx.Value.new([[1,2],[3,2]])\n    [\n    [\n      %FeelEx.Value{value: 1, type: :number},\n      %FeelEx.Value{value: 2, type: :number}\n    ],\n    [\n      %FeelEx.Value{value: 3, type: :number},\n      %FeelEx.Value{value: 2, type: :number}\n    ]\n    ]\n    iex> FeelEx.Functions.union(list)\n    [\n    %FeelEx.Value{value: 1, type: :number},\n    %FeelEx.Value{value: 2, type: :number},\n    %FeelEx.Value{value: 3, type: :number}\n    ]","title":"FeelEx.Functions.union/1","ref":"FeelEx.Functions.html#union/1"},{"type":"function","doc":"Transforms every character in a given string into upper case.","title":"FeelEx.Functions.upper_case/1","ref":"FeelEx.Functions.html#upper_case/1"},{"type":"function","doc":"iex> string = FeelEx.Value.new(\"Aw dinja !!\")\n  %FeelEx.Value{value: \"Aw dinja !!\", type: :string}\n  iex> FeelEx.Functions.upper_case(string)\n  %FeelEx.Value{value: \"AW DINJA !!\", type: :string}","title":"Examples - FeelEx.Functions.upper_case/1","ref":"FeelEx.Functions.html#upper_case/1-examples"},{"type":"module","doc":"","title":"FeelEx.UnaryParser","ref":"FeelEx.UnaryParser.html"},{"type":"function","doc":"","title":"FeelEx.UnaryParser.do_parse_unary_expression/1","ref":"FeelEx.UnaryParser.html#do_parse_unary_expression/1"},{"type":"function","doc":"","title":"FeelEx.UnaryParser.parse_unary_expression/1","ref":"FeelEx.UnaryParser.html#parse_unary_expression/1"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}